MODULE_NAME='ClearoneConvergePro2GainMute' (DEV vdvLevel,DEV dvPanel)
(***********************************************************)
(***********************************************************)
(*  FILE_LAST_MODIFIED_ON: 04/04/2006  AT: 11:33:16        *)
(***********************************************************)
(* System Type : NetLinx                                   *)
(***********************************************************)
(* REV HISTORY:                                            *)
(***********************************************************)
(*
    $History: $
*)    
(***********************************************************)
(*          DEVICE NUMBER DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_DEVICE

(***********************************************************)
(*               CONSTANT DEFINITIONS GO BELOW             *)
(***********************************************************)
#INCLUDE 'SNAPI'

DEFINE_CONSTANT

(***********************************************************)
(*              DATA TYPE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_TYPE

(***********************************************************)
(*               VARIABLE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_VARIABLE

(***********************************************************)
(*               LATCHING DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_LATCHING

(***********************************************************)
(*       MUTUALLY EXCLUSIVE DEFINITIONS GO BELOW           *)
(***********************************************************)
DEFINE_MUTUALLY_EXCLUSIVE

(***********************************************************)
(*        SUBROUTINE/FUNCTION DEFINITIONS GO BELOW         *)
(***********************************************************)
DEFINE_CALL 'RefreshLevel'
{
	SEND_LEVEL dvPanel, 1, LEVEL.VALUE
}

(***********************************************************)
(*                STARTUP CODE GOES BELOW                  *)
(***********************************************************)
DEFINE_START

(***********************************************************)
(*                THE EVENTS GO BELOW                      *)
(***********************************************************)
DEFINE_EVENT

BUTTON_EVENT[dvPanel, 152]						// LEVEL RAISE
{
	PUSH:
	{
		TO[vdvLevel, AUDIOPROC_LEVEL_UP];
	}
}

BUTTON_EVENT[dvPanel, 153]						// LEVEL LOWER
{
	PUSH:
	{
		TO[vdvLevel, AUDIOPROC_LEVEL_DN];
	}
}

BUTTON_EVENT[dvPanel, 154]						// CYCLE STATE
{
	PUSH:
	{
		PULSE[vdvLevel, 26]
	}
}

CHANNEL_EVENT[vdvLevel, 199]
{
	ON:
	{
		ON[dvPanel, 154]
	}
	OFF:
	{
		OFF[dvPanel, 154]
	}
}

LEVEL_EVENT[vdvLevel, AUDIOPROC_LVL]
{
	CALL 'RefreshLevel'
}

Data_Event [dvPanel]
{
	Online:
	{
		CALL 'RefreshLevel'
		IF ([vdvLevel, 199])
		{
			ON[dvPanel, 154]
		}
		ELSE
		{
			OFF[dvPanel, 154]
		}
	}
}

(***********************************************************)
(*            THE ACTUAL PROGRAM GOES BELOW                *)
(***********************************************************)
DEFINE_PROGRAM

[dvPanel, 152] = [vdvLevel, AUDIOPROC_LEVEL_UP];
[dvPanel, 153] = [vdvLevel, AUDIOPROC_LEVEL_DN];

(***********************************************************)
(*                     END OF PROGRAM                      *)
(*        DO NOT PUT ANY CODE BELOW THIS COMMENT           *)
(***********************************************************)
