MODULE_NAME='ClearoneConvergePro2RoomState' (DEV vdvState[],DEV dvPanel,INTEGER PanelButtons[])
(***********************************************************)
(***********************************************************)
(*  FILE_LAST_MODIFIED_ON: 04/04/2006  AT: 11:33:16        *)
(***********************************************************)
(* System Type : NetLinx                                   *)
(***********************************************************)
(* REV HISTORY:                                            *)
(***********************************************************)
(*
    $History: $
*)    
(***********************************************************)
(*          DEVICE NUMBER DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_DEVICE

(***********************************************************)
(*               CONSTANT DEFINITIONS GO BELOW             *)
(***********************************************************)
#INCLUDE 'SNAPI'

DEFINE_CONSTANT

tlRoomState	= 1

(***********************************************************)
(*              DATA TYPE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_TYPE

(***********************************************************)
(*               VARIABLE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_VARIABLE

Long lTimeRoomState[] = {300}

VOLATILE INTEGER nWallStates[3];
(***********************************************************)
(*               LATCHING DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_LATCHING

(***********************************************************)
(*       MUTUALLY EXCLUSIVE DEFINITIONS GO BELOW           *)
(***********************************************************)
DEFINE_MUTUALLY_EXCLUSIVE

(***********************************************************)
(*        SUBROUTINE/FUNCTION DEFINITIONS GO BELOW         *)
(***********************************************************)
(* EXAMPLE: DEFINE_FUNCTION <RETURN_TYPE> <NAME> (<PARAMETERS>) *)
(* EXAMPLE: DEFINE_CALL '<NAME>' (<PARAMETERS>) *)
DEFINE_CALL 'Update Room State Feedback'
{
	SELECT
	{
		ACTIVE ([vdvState[1], AUDIOPROC_STATE_FB] = true AND [vdvState[2], AUDIOPROC_STATE_FB] = true AND [vdvState[3], AUDIOPROC_STATE_FB] = true):
		{
			SEND_COMMAND dvPanel, "'^ANI-1,1,1,1'"
			SEND_COMMAND dvPanel, "'^ANI-2,1,1,1'"
			SEND_COMMAND dvPanel, "'^ANI-3,1,1,1'"
			SEND_COMMAND dvPanel, "'^ANI-4,1,1,1'"
			SEND_COMMAND dvPanel, "'^TXT-1,0,Room 1'"
			SEND_COMMAND dvPanel, "'^TXT-2,0,Room 2'"
			SEND_COMMAND dvPanel, "'^TXT-3,0,Room 3'"
			SEND_COMMAND dvPanel, "'^TXT-4,0,Room 4'"
			SEND_COMMAND dvPanel, "'^BOP-5,0,255'"
			SEND_COMMAND dvPanel, "'^BOP-6,0,255'"
			SEND_COMMAND dvPanel, "'^BOP-7,0,255'"
		}
		ACTIVE ([vdvState[1], AUDIOPROC_STATE_FB] = false AND [vdvState[2], AUDIOPROC_STATE_FB] = true AND [vdvState[3], AUDIOPROC_STATE_FB] = true):
		{
			SEND_COMMAND dvPanel, "'^ANI-1,2,2,1'"
			SEND_COMMAND dvPanel, "'^ANI-2,2,2,1'"
			SEND_COMMAND dvPanel, "'^ANI-3,1,1,1'"
			SEND_COMMAND dvPanel, "'^ANI-4,1,1,1'"
			SEND_COMMAND dvPanel, "'^TXT-1,0,Room 1'"
			SEND_COMMAND dvPanel, "'^TXT-2,0,Room 1'"
			SEND_COMMAND dvPanel, "'^TXT-3,0,Room 3'"
			SEND_COMMAND dvPanel, "'^TXT-4,0,Room 4'"
			SEND_COMMAND dvPanel, "'^BOP-5,0,0'"
			SEND_COMMAND dvPanel, "'^BOP-6,0,255'"
			SEND_COMMAND dvPanel, "'^BOP-7,0,255'"
		}
		ACTIVE ([vdvState[1], AUDIOPROC_STATE_FB] = false AND [vdvState[2], AUDIOPROC_STATE_FB] = false AND [vdvState[3], AUDIOPROC_STATE_FB] = true):
		{
			SEND_COMMAND dvPanel, "'^ANI-1,2,2,1'"
			SEND_COMMAND dvPanel, "'^ANI-2,2,2,1'"
			SEND_COMMAND dvPanel, "'^ANI-3,2,2,1'"
			SEND_COMMAND dvPanel, "'^ANI-4,1,1,1'"
			SEND_COMMAND dvPanel, "'^TXT-1,0,Room 1'"
			SEND_COMMAND dvPanel, "'^TXT-2,0,Room 1'"
			SEND_COMMAND dvPanel, "'^TXT-3,0,Room 1'"
			SEND_COMMAND dvPanel, "'^TXT-4,0,Room 4'"
			SEND_COMMAND dvPanel, "'^BOP-5,0,0'"
			SEND_COMMAND dvPanel, "'^BOP-6,0,0'"
			SEND_COMMAND dvPanel, "'^BOP-7,0,255'"
		}
		ACTIVE ([vdvState[1], AUDIOPROC_STATE_FB]  = true AND [vdvState[2], AUDIOPROC_STATE_FB] = true AND [vdvState[3], AUDIOPROC_STATE_FB] = false):
		{
			SEND_COMMAND dvPanel, "'^ANI-1,1,1,1'"
			SEND_COMMAND dvPanel, "'^ANI-2,1,1,1'"
			SEND_COMMAND dvPanel, "'^ANI-3,2,2,1'"
			SEND_COMMAND dvPanel, "'^ANI-4,2,2,1'"
			SEND_COMMAND dvPanel, "'^TXT-1,0,Room 1'"
			SEND_COMMAND dvPanel, "'^TXT-2,0,Room 2'"
			SEND_COMMAND dvPanel, "'^TXT-3,0,Room 3'"
			SEND_COMMAND dvPanel, "'^TXT-4,0,Room 3'"
			SEND_COMMAND dvPanel, "'^BOP-5,0,0'"
			SEND_COMMAND dvPanel, "'^BOP-6,0,255'"
			SEND_COMMAND dvPanel, "'^BOP-7,0,0'"
		}
		ACTIVE ([vdvState[1], AUDIOPROC_STATE_FB] = true AND [vdvState[2], AUDIOPROC_STATE_FB] = false AND [vdvState[3], AUDIOPROC_STATE_FB] = false):
		{
			SEND_COMMAND dvPanel, "'^ANI-1,1,1,1'"
			SEND_COMMAND dvPanel, "'^ANI-2,2,2,1'"
			SEND_COMMAND dvPanel, "'^ANI-3,2,2,1'"
			SEND_COMMAND dvPanel, "'^ANI-4,2,2,1'"
			SEND_COMMAND dvPanel, "'^TXT-1,0,Room 1'"
			SEND_COMMAND dvPanel, "'^TXT-2,0,Room 2'"
			SEND_COMMAND dvPanel, "'^TXT-3,0,Room 2'"
			SEND_COMMAND dvPanel, "'^TXT-4,0,Room 2'"
			SEND_COMMAND dvPanel, "'^BOP-5,0,255'"
			SEND_COMMAND dvPanel, "'^BOP-6,0,0'"
			SEND_COMMAND dvPanel, "'^BOP-7,0,0'"
		}
		ACTIVE ([vdvState[1], AUDIOPROC_STATE_FB] = false AND [vdvState[2], AUDIOPROC_STATE_FB] = true AND [vdvState[3], AUDIOPROC_STATE_FB] = false):
		{
			SEND_COMMAND dvPanel, "'^ANI-1,2,2,1'"
			SEND_COMMAND dvPanel, "'^ANI-2,2,2,1'"
			SEND_COMMAND dvPanel, "'^ANI-3,3,3,1'"
			SEND_COMMAND dvPanel, "'^ANI-4,3,3,1'"
			SEND_COMMAND dvPanel, "'^TXT-1,0,Room 1'"
			SEND_COMMAND dvPanel, "'^TXT-2,0,Room 1'"
			SEND_COMMAND dvPanel, "'^TXT-3,0,Room 3'"
			SEND_COMMAND dvPanel, "'^TXT-4,0,Room 3'"
		}
		ACTIVE ([vdvState[1], AUDIOPROC_STATE_FB] = true AND [vdvState[2], AUDIOPROC_STATE_FB] = false AND [vdvState[3], AUDIOPROC_STATE_FB] = true):
		{
			SEND_COMMAND dvPanel, "'^ANI-1,1,1,1'"
			SEND_COMMAND dvPanel, "'^ANI-2,2,2,1'"
			SEND_COMMAND dvPanel, "'^ANI-3,2,2,1'"
			SEND_COMMAND dvPanel, "'^ANI-4,1,1,1'"
			SEND_COMMAND dvPanel, "'^TXT-1,0,Room 1'"
			SEND_COMMAND dvPanel, "'^TXT-2,0,Room 2'"
			SEND_COMMAND dvPanel, "'^TXT-3,0,Room 2'"
			SEND_COMMAND dvPanel, "'^TXT-4,0,Room 3'"
			SEND_COMMAND dvPanel, "'^BOP-5,0,255'"
			SEND_COMMAND dvPanel, "'^BOP-6,0,0'"
			SEND_COMMAND dvPanel, "'^BOP-7,0,255'"
		}
		ACTIVE ([vdvState[1], AUDIOPROC_STATE_FB] = false AND [vdvState[2], AUDIOPROC_STATE_FB] = false AND [vdvState[3], AUDIOPROC_STATE_FB] = false):
		{
			SEND_COMMAND dvPanel, "'^ANI-1,2,2,1'"
			SEND_COMMAND dvPanel, "'^ANI-2,2,2,1'"
			SEND_COMMAND dvPanel, "'^ANI-3,2,2,1'"
			SEND_COMMAND dvPanel, "'^ANI-4,2,2,1'"
			SEND_COMMAND dvPanel, "'^TXT-1,0,Room 1'"
			SEND_COMMAND dvPanel, "'^TXT-2,0,Room 1'"
			SEND_COMMAND dvPanel, "'^TXT-3,0,Room 1'"
			SEND_COMMAND dvPanel, "'^TXT-4,0,Room 1'"
			
			
			SEND_COMMAND dvPanel, "'^BOP-5,0,0'"
			SEND_COMMAND dvPanel, "'^BOP-6,0,0'"
			SEND_COMMAND dvPanel, "'^BOP-7,0,0'"
		}
	}
}

(***********************************************************)
(*                STARTUP CODE GOES BELOW                  *)
(***********************************************************)
DEFINE_START

TIMELINE_CREATE (tlRoomState, lTimeRoomState, 1, TIMELINE_ABSOLUTE, TIMELINE_REPEAT)

(***********************************************************)
(*                THE EVENTS GO BELOW                      *)
(***********************************************************)
DEFINE_EVENT

TIMELINE_EVENT [tlRoomState]
{
	STACK_VAR INTEGER nButton;

	FOR (nButton = 1; nButton <= MAX_LENGTH_ARRAY(PanelButtons); nButton++)
	{
		if (nWallStates[nButton] != [vdvState[nButton], AUDIOPROC_STATE_FB])
		{
			nWallStates[nButton] = [vdvState[nButton], AUDIOPROC_STATE_FB];
			CALL 'Update Room State Feedback'
		}
		
		[dvPanel, PanelButtons[nButton]] = ![vdvState[nButton], AUDIOPROC_STATE_FB]
	}
}

BUTTON_EVENT[dvPanel, PanelButtons]						
{
	PUSH:
	{
		PULSE[vdvState[BUTTON.INPUT.CHANNEL], AUDIOPROC_STATE]
	}
}

(*****************************************************************)
(*                                                               *)
(*                      !!!! WARNING !!!!                        *)
(*                                                               *)
(* Due to differences in the underlying architecture of the      *)
(* X-Series masters, changing variables in the DEFINE_PROGRAM    *)
(* section of code can negatively impact program performance.    *)
(*                                                               *)
(* See Differences in DEFINE_PROGRAM Program Execution section *)
(* of the NX-Series Controllers WebConsole & Programming Guide   *)
(* for additional and alternate coding methodologies.            *)
(*****************************************************************)

DEFINE_PROGRAM

(*****************************************************************)
(*                       END OF PROGRAM                          *)
(*                                                               *)
(*         !!!  DO NOT PUT ANY CODE BELOW THIS COMMENT  !!!      *)
(*                                                               *)
(*****************************************************************)
