MODULE_NAME='Clearone_SkypeDialer_UI' (DEV vdvModule, DEV dvPanel[])
(***********************************************************)
(***********************************************************)
(*  FILE_LAST_MODIFIED_ON: 04/04/2006  AT: 11:33:16        *)
(***********************************************************)
(* System Type : NetLinx                                   *)
(***********************************************************)
(* REV HISTORY:                                            *)
(***********************************************************)
(*
    $History: $
*)    
(***********************************************************)
(*          DEVICE NUMBER DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_DEVICE

(***********************************************************)
(*               CONSTANT DEFINITIONS GO BELOW             *)
(***********************************************************)
#INCLUDE 'SNAPI'
DEFINE_CONSTANT

MAX_SESSIONS = 10;

TL_FEEDBACK = 1;
LONG TL_FEEDBACK_TIMES[] = { 300 };

(***********************************************************)
(*              DATA TYPE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_TYPE

(***********************************************************)
(*               VARIABLE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_VARIABLE

CHAR cRegStatus[DUET_MAX_PARAM_LEN];
CHAR cMeetingID[DUET_MAX_PARAM_LEN];
CHAR cTextInputField[DUET_MAX_PARAM_LEN];
////////////////////////////////////////////////////////////
// Dialer
////////////////////////////////////////////////////////////
VOLATILE CHAR cKeypadText[100];
VOLATILE CHAR cDigits[] = '0123456789*#+';
VOLATILE INTEGER addKeypadText = 400;
VOLATILE INTEGER btnDialKeypad[] = 
{
	400,															// Digit 0
	401,															// Digit 1
	402,															// Digit 2
	403,															// Digit 3
	404,															// Digit 4
	405,															// Digit 5
	406,															// Digit 6
	407,															// Digit 7
	408,															// Digit 8
	409,															// Digit 9
	410,															// Digit *
	411,															// Digit #
	412 															// Digit +
}

////////////////////////////////////////////////////////////
// Contact List
////////////////////////////////////////////////////////////
VOLATILE INTEGER btnContactFunctions[] = 
{
	451,															// SKYPE_DIAL_CONTACT
	452,															// SKYPE_ADD_CONTACT_TO_GROUP
	453,															// SKYPE_REMOVE_CONTACT_FROM_GROUP
	454,															// SKYPE_REMOVE_CONTACT_FROM_ALL_GROUPS
	455,															// SKYPE_ADD_CONTACT_TO_ACTIVE_SESSION
	456,															// SKYPE_CREATE_SESSION_USING_SELECTION
	457,															// SKYPE_DELETE_GROUP
	458,															// SKYPE_PERFORM_SEARCH
	459																// SKYPE_CONTACT_LIST_SELECTION-0
}

VOLATILE CHAR cContactFunctionCmds[][DUET_MAX_CMD_LEN] = 
{
	'SKYPE_DIAL_CONTACT',
	'SKYPE_ADD_CONTACT_TO_GROUP',
	'SKYPE_REMOVE_CONTACT_FROM_GROUP',
	'SKYPE_REMOVE_CONTACT_FROM_ALL_GROUPS',
	'SKYPE_ADD_CONTACT_TO_ACTIVE_SESSION',
	'SKYPE_CREATE_SESSION_USING_SELECTION',
	'SKYPE_DELETE_GROUP',
	'SKYPE_PERFORM_SEARCH',
	'SKYPE_CONTACT_LIST_SELECTION-0'
}

VOLATILE INTEGER addSearchField = 300;
VOLATILE INTEGER addContactListName = 451;
VOLATILE INTEGER addContactListGroup = 452;
VOLATILE INTEGER addContactList = 500;
VOLATILE INTEGER addContactListItems[] = 
{
	501,															// Contact 001
	502,															// Contact 002
	503,															// Contact 003
	504,															// Contact 004
	505,															// Contact 005
	506,															// Contact 006
	507,															// Contact 007
	508,															// Contact 008
	509,															// Contact 009
	510,															// Contact 010
	511,															// Contact 011
	512,															// Contact 012
	513,															// Contact 013
	514,															// Contact 014
	515,															// Contact 015
	516,															// Contact 016
	517,															// Contact 017
	518,															// Contact 018
	519,															// Contact 019
	520,															// Contact 020
	521,															// Contact 021
	522,															// Contact 022
	523,															// Contact 023
	524,															// Contact 024
	525,															// Contact 025
	526,															// Contact 026
	527,															// Contact 027
	528,															// Contact 028
	529,															// Contact 029
	530,															// Contact 030
	531,															// Contact 031
	532,															// Contact 032
	533,															// Contact 033
	534,															// Contact 034
	535,															// Contact 035
	536,															// Contact 036
	537,															// Contact 037
	538,															// Contact 038
	539,															// Contact 039
	540,															// Contact 040
	541,															// Contact 041
	542,															// Contact 042
	543,															// Contact 043
	544,															// Contact 044
	545,															// Contact 045
	546,															// Contact 046
	547,															// Contact 047
	548,															// Contact 048
	549,															// Contact 049
	550 															// Contact 050
}

VOLATILE INTEGER btnContactListItems[] = 
{
	501,															// Contact 001
	502,															// Contact 002
	503,															// Contact 003
	504,															// Contact 004
	505,															// Contact 005
	506,															// Contact 006
	507,															// Contact 007
	508,															// Contact 008
	509,															// Contact 009
	510,															// Contact 010
	511,															// Contact 011
	512,															// Contact 012
	513,															// Contact 013
	514,															// Contact 014
	515,															// Contact 015
	516,															// Contact 016
	517,															// Contact 017
	518,															// Contact 018
	519,															// Contact 019
	520,															// Contact 020
	521,															// Contact 021
	522,															// Contact 022
	523,															// Contact 023
	524,															// Contact 024
	525,															// Contact 025
	526,															// Contact 026
	527,															// Contact 027
	528,															// Contact 028
	529,															// Contact 029
	530,															// Contact 030
	531,															// Contact 031
	532,															// Contact 032
	533,															// Contact 033
	534,															// Contact 034
	535,															// Contact 035
	536,															// Contact 036
	537,															// Contact 037
	538,															// Contact 038
	539,															// Contact 039
	540,															// Contact 040
	541,															// Contact 041
	542,															// Contact 042
	543,															// Contact 043
	544,															// Contact 044
	545,															// Contact 045
	546,															// Contact 046
	547,															// Contact 047
	548,															// Contact 048
	549,															// Contact 049
	550 															// Contact 050
}

////////////////////////////////////////////////////////////
// Session List
////////////////////////////////////////////////////////////
VOLATILE INTEGER addActiveSessionName = 651;
VOLATILE INTEGER addActiveSessionID = 652;
VOLATILE INTEGER addActiveSessionState = 653;
VOLATILE INTEGER addCallerID = 654;
VOLATILE INTEGER addSessionList = 600;
VOLATILE INTEGER addSessionListItems[] = 
{
	601,															// Session 001
	602,															// Session 002
	603,															// Session 003
	604,															// Session 004
	605,															// Session 005
	606,															// Session 006
	607,															// Session 007
	608,															// Session 008
	609,															// Session 009
	610 															// Session 010
}

VOLATILE INTEGER btnSessionListItems[] = 
{
	601,															// Session 001
	602,															// Session 002
	603,															// Session 003
	604,															// Session 004
	605,															// Session 005
	606,															// Session 006
	607,															// Session 007
	608,															// Session 008
	609,															// Session 009
	610 															// Session 010
}

VOLATILE INTEGER btnSessionFunctions[] = 
{
	651,															// SKYPE_CALL_ACCEPT
	652,															// SKYPE_CALL_LEAVE
	653,															// SKYPE_CALL_RESUME
	654,															// SKYPE_CALL_HOLD
	655, 															// SKYPE_CALL_REJECT
	656 															// SKYPE_MEET_NOW
}

VOLATILE CHAR cSessionFunctionCmds[][DUET_MAX_CMD_LEN] = 
{
	'SKYPE_CALL_ACCEPT',
	'SKYPE_CALL_LEAVE',
	'SKYPE_CALL_RESUME',
	'SKYPE_CALL_HOLD',
	'SKYPE_CALL_REJECT',
	'SKYPE_MEET_NOW'
}

VOLATILE CHAR cActiveSessions[MAX_SESSIONS][DUET_MAX_PARAM_LEN];
VOLATILE CHAR cSelectedSession[DUET_MAX_PARAM_LEN];
(***********************************************************)
(*               LATCHING DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_LATCHING

(***********************************************************)
(*       MUTUALLY EXCLUSIVE DEFINITIONS GO BELOW           *)
(***********************************************************)
DEFINE_MUTUALLY_EXCLUSIVE

(***********************************************************)
(*        SUBROUTINE/FUNCTION DEFINITIONS GO BELOW         *)
(***********************************************************)
DEFINE_FUNCTION BuildContactList(INTEGER ShowCount, INTEGER TotalCount)
{
	STACK_VAR INTEGER nIndex;
	STACK_VAR CHAR nSubPageName[100];
	
	FOR (nIndex = 1; nIndex <= TotalCount; nIndex++)
	{
		nSubPageName = FORMAT('Contact%03d', nIndex);
		
		SEND_COMMAND dvPanel,"'^SHD-',ITOA(addContactList),',',nSubPagename";
	}
	
	FOR (nIndex = ShowCount; nIndex > 0; nIndex--)
	{
		nSubPageName = FORMAT('Contact%03d', nIndex);
		
		SEND_COMMAND dvPanel,"'^SSH-',ITOA(addContactList),',',nSubPagename";
	}
}

DEFINE_FUNCTION BuildSessionList(INTEGER ShowCount, INTEGER TotalCount)
{
	STACK_VAR INTEGER nIndex;
	STACK_VAR CHAR nSubPageName[100];
	
	FOR (nIndex = 1; nIndex <= TotalCount; nIndex++)
	{
		nSubPageName = FORMAT('Session%03d', nIndex);
		
		cActiveSessions[nIndex] = "";
		
		SEND_COMMAND dvPanel,"'^SHD-',ITOA(addSessionList),',',nSubPagename";
	}
	
	FOR (nIndex = ShowCount; nIndex > 0; nIndex--)
	{
		nSubPageName = FORMAT('Session%03d', nIndex);
		
		SEND_COMMAND dvPanel,"'^SSH-',ITOA(addSessionList),',',nSubPagename";
	}
}
(***********************************************************)
(*                STARTUP CODE GOES BELOW                  *)
(***********************************************************)
DEFINE_START

TIMELINE_CREATE(TL_FEEDBACK, TL_FEEDBACK_TIMES, 1, TIMELINE_ABSOLUTE, TIMELINE_REPEAT);

(***********************************************************)
(*                THE EVENTS GO BELOW                      *)
(***********************************************************)
DEFINE_EVENT

////////////////////////////////////////////////////////////
// Feedback
////////////////////////////////////////////////////////////
TIMELINE_EVENT[TL_FEEDBACK]
{
	[dvPanel, 2] = [vdvModule, DEVICE_COMMUNICATING];
	[dvPanel, 3] = [vdvModule, DATA_INITIALIZED];
	[dvPanel, 4] = (cRegStatus == 'REGISTERED');
}
////////////////////////////////////////////////////////////
// Keypad
////////////////////////////////////////////////////////////
BUTTON_EVENT[dvPanel, btnDialKeypad]
{
	PUSH:
	{
		STACK_VAR INTEGER nButton;
		
		TO[BUTTON.INPUT];
		
		nButton = GET_LAST(btnDialKeypad);
		
		IF ([vdvModule, DIAL_OFF_HOOK_FB])
			SEND_COMMAND vdvModule,"'DTMF-',cDigits[nButton]";
		
		ELSE
		{
			cKeypadText = "cKeypadText, cDigits[nButton]";
			
			SEND_COMMAND dvPanel,"'^TXT-',ITOA(addKeypadText),',0,',cKeypadText";
		}
	}
}

BUTTON_EVENT[dvPanel, 413]					// CLEAR
{
	PUSH:
	{
		TO[BUTTON.INPUT];
		
		cKeypadText = "";
		SEND_COMMAND dvPanel,"'^TXT-',ITOA(addKeypadText),',0,',cKeypadText";
	}
}

BUTTON_EVENT[dvPanel, 414]					// BACK
{
	PUSH:
	{
		IF (LENGTH_STRING(cKeypadText))
		{
			TO[BUTTON.INPUT];

			SET_LENGTH_STRING(cKeypadText, LENGTH_STRING(cKeypadText) - 1);
			
			SEND_COMMAND dvPanel,"'^TXT-',ITOA(addKeypadText),',0,',cKeypadText";
		}
	}
}

BUTTON_EVENT[dvPanel, 415]					// DIAL
{
	PUSH:
	{
		IF (LENGTH_STRING(cKeypadText))
		{
			TO[BUTTON.INPUT];
			
			SEND_COMMAND vdvModule,"'DIALNUMBER-',cKeypadText";
			
			cKeypadText = "";
		}
	}
}

////////////////////////////////////////////////////////////
// Contacts
////////////////////////////////////////////////////////////
BUTTON_EVENT[dvPanel, btnContactFunctions]
{
	PUSH:
	{
		TO[BUTTON.INPUT];
		SEND_COMMAND vdvModule,"cContactFunctionCmds[GET_LAST(btnContactFunctions)]";
	}
}

BUTTON_EVENT[dvPanel, btnContactListItems]
{
	PUSH:
	{
		TO[BUTTON.INPUT];
		SEND_COMMAND vdvModule,"'SKYPE_CONTACT_LIST_SELECTION-',ITOA(GET_LAST(btnContactListItems))";
	}
}

////////////////////////////////////////////////////////////
// Panel
////////////////////////////////////////////////////////////
BUTTON_EVENT[dvPanel, 300]					// SEARCH_FILTER
{
	PUSH:
	{
		cTextInputField = 'SEARCH_FILTER';
	}
}

BUTTON_EVENT[dvPanel, 301]					// MEETING_ID
{
	PUSH:
	{
		cTextInputField = 'MEETING_ID';
	}
}

DATA_EVENT[dvPanel]
{
	STRING:
	{
		STACK_VAR CHAR cHeader[DUET_MAX_HDR_LEN];
		
		IF (FIND_STRING(DATA.TEXT,'-', 1) > 0)
			cHeader = DuetParseCmdHeader(DATA.TEXT);
		
		IF (FIND_STRING(DATA.TEXT,'ABORT', 1) == 0)
		{
			SWITCH (cHeader)
			{
				CASE 'SEARCH_FILTER':
				{
					SEND_COMMAND vdvModule,"'SKYPE_FILTER_SEARCH_TEXT-',DATA.TEXT";
				}
				CASE 'MEETING_ID':
				{
					cMeetingID = DATA.TEXT;
				}
				DEFAULT:
				{
					SWITCH(cTextInputField)
					{
						CASE 'SEARCH_FILTER':
						{
							SEND_COMMAND vdvModule,"'SKYPE_FILTER_SEARCH_TEXT-',DATA.TEXT";
						}
						CASE 'MEETING_ID':
						{
							cMeetingID = DATA.TEXT;
						}
					}
					
					cTextInputField = '';
				}
			}
		}
	}	
	
	ONLINE:
	{
		WAIT 50 'dvPanel SETTLE'
		{
			IF ([vdvModule, DATA_INITIALIZED])
			{
				SEND_COMMAND vdvModule,"'?SKYPE_CONTACT_LIST'";
				SEND_COMMAND vdvModule,"'?SKYPE_SESSION_LIST'";
				SEND_COMMAND vdvModule,"'?SKYPE_ACTIVE_SESSION'";
				SEND_COMMAND vdvModule,"'?SKYPE_REG_STATUS'";
				SEND_COMMAND vdvModule,"'?SKYPE_FILTER_SEARCH_TEXT'";
			}
		}
	}	
}

////////////////////////////////////////////////////////////
// Sessions
////////////////////////////////////////////////////////////
BUTTON_EVENT[dvPanel, btnSessionFunctions]
{
	PUSH:
	{
		TO[BUTTON.INPUT];
		SEND_COMMAND vdvModule,"cSessionFunctionCmds[GET_LAST(btnSessionFunctions)]";
	}
}

BUTTON_EVENT[dvPanel, btnSessionListItems]
{
	PUSH:
	{
		TO[BUTTON.INPUT];
		SEND_COMMAND vdvModule,"'SKYPE_SELECT_SESSION-',ITOA(GET_LAST(btnSessionListItems))";
	}
}

BUTTON_EVENT[dvPanel, 661] 					// Join Meeting
{
	PUSH:
	{
		IF (LENGTH_STRING(cMeetingID))
		{
			TO[BUTTON.INPUT];
			SEND_COMMAND vdvModule,"'SKYPE_JOIN_MEETING-',cMeetingID";
		}
	}
}

BUTTON_EVENT[dvPanel, 662] 					// Join Conference
{
	PUSH:
	{
		IF (LENGTH_STRING(cMeetingID))
		{
			TO[BUTTON.INPUT];
			SEND_COMMAND vdvModule,"'SKYPE_JOIN_CONFERENCE-',cMeetingID";
		}
	}
}

TIMELINE_EVENT[TL_FEEDBACK]
{
	STACK_VAR INTEGER nIndex;
	
	FOR (nIndex = 1; nIndex <= MAX_SESSIONS; nIndex++)
	{
		[dvPanel, btnSessionListItems[nIndex]] = (LENGTH_STRING(cActiveSessions[nIndex]) > 0 && cSelectedSession == cActiveSessions[nIndex]);
	}
}

////////////////////////////////////////////////////////////
// Module
////////////////////////////////////////////////////////////
DATA_EVENT[vdvModule]
{
	COMMAND:
	{
		STACK_VAR CHAR cHeader[DUET_MAX_HDR_LEN];
		STACK_VAR CHAR cParam1[DUET_MAX_PARAM_LEN];	
		STACK_VAR CHAR cParam2[DUET_MAX_PARAM_LEN];	
		STACK_VAR INTEGER nParam1;
		STACK_VAR INTEGER nParam2;
		
		cHeader = DuetParseCmdHeader(DATA.TEXT);
		
		SWITCH (cHeader)
		{
			CASE 'SKYPE_CONTACT_LIST':
			{
				// Item
				nParam1 = ATOI(DuetParseCmdParam(DATA.TEXT));
				// Count
				nParam2 = ATOI(DuetParseCmdParam(DATA.TEXT));
				
				IF (nParam1 <= 1)
					BuildContactList(nParam2, LENGTH_ARRAY(addContactListItems));
					
				cParam1 = DuetParseCmdParam(DATA.TEXT);			
				
				IF (nParam1)
					SEND_COMMAND dvPanel,"'^TXT-',ITOA(addContactListItems[nParam1]),',0,', cParam1";
			}
			CASE 'SKYPE_CONTACT_LIST_TYPE':
			{
			}
			CASE 'SKYPE_CONTACT_LIST_HELP_TEXT':
			{
			}
			CASE 'SKYPE_CONTACT_LIST_SELECTION_ID':
			{
			}
			CASE 'SKYPE_CONTACT_LIST_SELECTION_NAME':
			{
				cParam1 = DuetParseCmdParam(DATA.TEXT);
				
				SEND_COMMAND dvPanel,"'^TXT-',ITOA(addContactListName),',0,', cParam1";
			}
			CASE 'SKYPE_CONTACT_LIST_SELECTION_TYPE':
			{
				cParam1 = DuetParseCmdParam(DATA.TEXT);
				
				SWITCH (cParam1)
				{
					CASE 'CONTACTS':
					{
						SEND_COMMAND dvPanel,'@PPN-ContactFunctions;Contacts'
					}
					CASE 'GROUPS':
					{
						SEND_COMMAND dvPanel,'@PPN-GroupFunctions;Contacts'
					}
					DEFAULT:
					{
						SEND_COMMAND dvPanel,'@PPF-ContactFunctions;Contacts'
					}
				}
			}
			CASE 'SKYPE_CONTACT_LIST_SELECTION_GROUP':
			{
				cParam1 = DuetParseCmdParam(DATA.TEXT);
				
				SEND_COMMAND dvPanel,"'^TXT-',ITOA(addContactListGroup),',0,', cParam1";
			}
			CASE 'SKYPE_SESSION_LIST':
			{
				// Item
				nParam1 = ATOI(DuetParseCmdParam(DATA.TEXT));
				// Count
				nParam2 = ATOI(DuetParseCmdParam(DATA.TEXT));
				
				IF (nParam1 <= 1)
					BuildSessionList(nParam2, LENGTH_ARRAY(addSessionListItems));
					
				cParam1 = DuetParseCmdParam(DATA.TEXT);
				
				IF (nParam1)
				{
					cActiveSessions[nParam1] = cParam1;
				
					SEND_COMMAND dvPanel,"'^TXT-',ITOA(addSessionListItems[nParam1]),',0,', cParam1";
				}
			}
			CASE 'SKYPE_ACTIVE_SESSION_MEETING_ID':
			{
				cParam1 = DuetParseCmdParam(DATA.TEXT);
				
				cSelectedSession = cParam1;
				
				SEND_COMMAND dvPanel,"'^TXT-',ITOA(addActiveSessionName),',0,', cParam1";
			}
			CASE 'SKYPE_ACTIVE_SESSION_STATUS':
			{
				cParam1 = DuetParseCmdParam(DATA.TEXT);
								
				SEND_COMMAND dvPanel,"'^TXT-',ITOA(addActiveSessionState),',0,', cParam1";
			}
			CASE 'SKYPE_ACTIVE_SESSION_URL':
			{
				cParam1 = DuetParseCmdParam(DATA.TEXT);
								
				SEND_COMMAND dvPanel,"'^TXT-',ITOA(addActiveSessionID),',0,', cParam1";
			}
			CASE 'SKYPE_ACTIVE_SESSION_IS_CONFERENCE':
			{
			}
			CASE 'SKYPE_ERROR_MESSAGE':
			{
			}
			CASE 'SKYPE_FILTER_SEARCH_TEXT':
			{
				cParam1 = DuetParseCmdParam(DATA.TEXT);
			
				SEND_COMMAND dvPanel,"'^TXT-',ITOA(addSearchField),',0,', cParam1";
			}
			CASE 'SKYPE_REG_STATUS':
			{
				cRegStatus = DuetParseCmdParam(DATA.TEXT);
			}
			CASE 'INCOMINGCALL':
			{
				cParam1 = DuetParseCmdParam(DATA.TEXT);
								
				SEND_COMMAND dvPanel,'@PPN-IncomingCall';
				SEND_COMMAND dvPanel,"'^TXT-',ITOA(addCallerID),',0,', cParam1";
			}
		}
	}
}
(***********************************************************)
(*                  END OF PROGRAM                         *)
(***********************************************************)
